// ********************************************* //
// *                                           * //
// *  TAdvLine VCL Component                   * //
// *   Version 1.0                             * //
// *                                           * //
// *   Developed by Fernando Santos            * //
// *     September/1997                        * //
// *                                           * //
// *   E-Mail: nop16327@mail.telepac.pt        * //
// *                                           * //
// ********************************************* //

unit AdvLine;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, 
     Forms, Graphics;

type
  TAdvLine = class(TCustomControl)
    private
        FColor : TColor;

        procedure AutoInitialize;
        procedure AutoDestroy;
        procedure Paint; override;

    protected
        procedure Click; override;
        procedure KeyPress(var Key : Char); override;
        procedure Loaded; override;

    public
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;

    published
        property OnClick;
        property OnDblClick;
        property OnDragDrop;
        property OnMouseDown;
        property OnMouseMove;
        property OnMouseUp;
        property OnKeyUp;
        property OnKeyDown;
        property OnKeyPress;
        property OnEnter;
        property OnExit;
        property Color : TColor read FColor write FColor default clBlack;

  end;

procedure Register;

implementation

procedure Register;
begin
     RegisterComponents('Samples', [TAdvLine]);
end;

procedure TAdvLine.AutoInitialize;
begin
     FColor := clBlack;
end;

procedure TAdvLine.AutoDestroy;
begin

end;

procedure TAdvLine.Click;
begin

end;

procedure TAdvLine.KeyPress(var Key : Char);
const
     TabKey = Char(VK_TAB);
     EnterKey = Char(VK_RETURN);
begin
     inherited KeyPress(Key);
end;

constructor TAdvLine.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     AutoInitialize;
end;

destructor TAdvLine.Destroy;
begin
     AutoDestroy;
     inherited Destroy;
end;

procedure TAdvLine.Loaded;
begin
     inherited Loaded;
end;

procedure TAdvLine.Paint;
begin
     Canvas.Brush.Color := FColor;
     Canvas.MoveTo(0, 0);
     Canvas.LineTo(Width, Height);
     
     if Height <= 10 then 
      begin
      Canvas.MoveTo(Width, Height-1);
      Canvas.LineTo(0, 0);
      end;
    
     if Width <= 10 then 
      begin
      Canvas.MoveTo(Width-1, Height);
      Canvas.LineTo(0, 0);
      end;  
end;


end.
